#ifndef H_KEY
#define H_KEY

int FastKeyDown(unsigned char code);

/***************/
/** Key codes **/
/***************/
#define K_F1	0x69
#define K_F2	0x59
#define K_F3	0x49
#define K_F4	0x39
#define K_F5	0x29
#define K_F6	0x19

#define K_SHIFT	0x68
#define K_OPTN	0x58
#define K_VARS	0x48
#define K_MENU	0x38
#define K_LEFT	0x28
#define K_UP	0x18

#define K_ALPHA	0x67
#define K_SQR	0x57
#define K_EXPO	0x47
#define K_EXIT	0x37
#define K_DOWN	0x27
#define K_RIGHT	0x17

#define K_THETA	0x66
#define K_LOG	0x56
#define K_LN	0x46
#define K_SIN	0x36
#define K_COS	0x26
#define K_TAN	0x16

#define K_FRAC	0x65
#define K_FD	0x55
#define K_LPAR	0x45
#define K_RPAR	0x35
#define K_COMMA	0x25
#define K_STORE	0x15

#define K_7	0x64
#define K_8	0x54
#define K_9	0x44
#define K_DEL	0x34

#define K_4	0x63
#define K_5	0x53
#define K_6	0x43
#define K_MULT	0x33
#define K_DIV	0x23

#define K_1	0x62
#define K_2	0x52
#define K_3	0x42
#define K_PLUS	0x32
#define K_MINUS	0x22

#define K_0	0x61
#define K_DOT	0x51
#define K_EXP	0x41
#define K_NEG	0x31
#define K_EXE	0x21

#define K_AC	0x00

/***********************/
/** Control registers **/
/***********************/

struct st_pa {
             union {
                   unsigned char BYTE;
                   struct {
                          unsigned char B7:1;
                          unsigned char B6:1;
                          unsigned char B5:1;
                          unsigned char B4:1;
                          unsigned char B3:1;
                          unsigned char B2:1;
                          unsigned char B1:1;
                          unsigned char B0:1;
                          }      BIT;
                   }            DR;
};
struct st_pb {
             union {
                   unsigned char BYTE;
                   struct {
                          unsigned char B7:1;
                          unsigned char B6:1;
                          unsigned char B5:1;
                          unsigned char B4:1;
                          unsigned char B3:1;
                          unsigned char B2:1;
                          unsigned char B1:1;
                          unsigned char B0:1;
                          }      BIT;
                   }            DR;
};
struct st_pm {
             union {
                   unsigned char BYTE;
                   struct {
                          unsigned char   :1;
                          unsigned char B6:1;
                          unsigned char   :1;
                          unsigned char B4:1;
                          unsigned char B3:1;
                          unsigned char B2:1;
                          unsigned char B1:1;
                          unsigned char B0:1;
                          }      BIT;
                   }            DR;
};
struct st_pfc {
              union {
                    unsigned short WORD;
                    struct {
                           unsigned short PA7MD:2;
                           unsigned short PA6MD:2;
                           unsigned short PA5MD:2;
                           unsigned short PA4MD:2;
                           unsigned short PA3MD:2;
                           unsigned short PA2MD:2;
                           unsigned short PA1MD:2;
                           unsigned short PA0MD:2;
                           }       BIT;
                    }           PACR;
              union {
                    unsigned short WORD;
                    struct {
                           unsigned short PB7MD:2;
                           unsigned short PB6MD:2;
                           unsigned short PB5MD:2;
                           unsigned short PB4MD:2;
                           unsigned short PB3MD:2;
                           unsigned short PB2MD:2;
                           unsigned short PB1MD:2;
                           unsigned short PB0MD:2;
                           }       BIT;
                    }           PBCR;
              union {
                    unsigned short WORD;
                    struct {
                           unsigned short PC7MD:2;
                           unsigned short PC6MD:2;
                           unsigned short PC5MD:2;
                           unsigned short PC4MD:2;
                           unsigned short PC3MD:2;
                           unsigned short PC2MD:2;
                           unsigned short PC1MD:2;
                           unsigned short PC0MD:2;
                           }       BIT;
                    }           PCCR;
              union {
                    unsigned short WORD;
                    struct {
                           unsigned short PD7MD:2;
                           unsigned short PD6MD:2;
                           unsigned short PD5MD:2;
                           unsigned short PD4MD:2;
                           unsigned short PD3MD:2;
                           unsigned short PD2MD:2;
                           unsigned short PD1MD:2;
                           unsigned short PD0MD:2;
                           }       BIT;
                    }           PDCR;
              union {
                    unsigned short WORD;
                    struct {
                           unsigned short PE7MD:2;
                           unsigned short PE6MD:2;
                           unsigned short PE5MD:2;
                           unsigned short PE4MD:2;
                           unsigned short PE3MD:2;
                           unsigned short PE2MD:2;
                           unsigned short PE1MD:2;
                           unsigned short PE0MD:2;
                           }       BIT;
                    }           PECR;
              union {
                    unsigned short WORD;
                    struct {
                           unsigned short PF7MD:2;
                           unsigned short PF6MD:2;
                           unsigned short PF5MD:2;
                           unsigned short PF4MD:2;
                           unsigned short PF3MD:2;
                           unsigned short PF2MD:2;
                           unsigned short PF1MD:2;
                           unsigned short PF0MD:2;
                           }       BIT;
                    }           PFCR;
              union {
                    unsigned short WORD;
                    struct {
                           unsigned short PG7MD:2;
                           unsigned short PG6MD:2;
                           unsigned short PG5MD:2;
                           unsigned short PG4MD:2;
                           unsigned short PG3MD:2;
                           unsigned short PG2MD:2;
                           unsigned short PG1MD:2;
                           unsigned short PG0MD:2;
                           }       BIT;
                    }           PGCR;
              union {
                    unsigned short WORD;
                    struct {
                           unsigned short      :2;
                           unsigned short PH6MD:2;
                           unsigned short PH5MD:2;
                           unsigned short PH4MD:2;
                           unsigned short PH3MD:2;
                           unsigned short PH2MD:2;
                           unsigned short PH1MD:2;
                           unsigned short PH0MD:2;
                           }       BIT;
                    }           PHCR;
              union {
                    unsigned short WORD;
                    struct {
                           unsigned short PJ7MD:2;
                           unsigned short PJ6MD:2;
                           unsigned short PJ5MD:2;
                           unsigned short PJ4MD:2;
                           unsigned short PJ3MD:2;
                           unsigned short PJ2MD:2;
                           unsigned short PJ1MD:2;
                           unsigned short PJ0MD:2;
                           }       BIT;
                    }           PJCR;
              union {
                    unsigned short WORD;
                    struct {
                           unsigned short PK7MD:2;
                           unsigned short PK6MD:2;
                           unsigned short PK5MD:2;
                           unsigned short PK4MD:2;
                           unsigned short PK3MD:2;
                           unsigned short PK2MD:2;
                           unsigned short PK1MD:2;
                           unsigned short PK0MD:2;
                           }       BIT;
                    }           PKCR;
              union {
                    unsigned short WORD;
                    struct {
                           unsigned short      :8;
                           unsigned short PL3MD:2;
                           unsigned short PL2MD:2;
                           unsigned short PL1MD:2;
                           unsigned short PL0MD:2;
                           }       BIT;
                    }           PLCR;
              union {
                    unsigned short WORD;
                    struct {
                           unsigned short       :4;
                           unsigned short SCP5MD:2;
                           unsigned short SCP4MD:2;
                           unsigned short SCP3MD:2;
                           unsigned short SCP2MD:2;
                           unsigned short SCP1MD:2;
                           unsigned short SCP0MD:2;
                           }       BIT;
                    }           SCPCR;
              union {
                    unsigned short WORD;
                    struct {
                           unsigned short      :2;
                           unsigned short PM6MD:2;
                           unsigned short      :2;
                           unsigned short PM4MD:2;
                           unsigned short PM3MD:2;
                           unsigned short PM2MD:2;
                           unsigned short PM1MD:2;
                           unsigned short PM0MD:2;
                           }       BIT;
                    }           PMCR;
              union {
                    unsigned short WORD;
                    struct {
                           unsigned short PN7MD:2;
                           unsigned short PN6MD:2;
                           unsigned short PN5MD:2;
                           unsigned short PN4MD:2;
                           unsigned short PN3MD:2;
                           unsigned short PN2MD:2;
                           unsigned short PN1MD:2;
                           unsigned short PN0MD:2;
                           }       BIT;
                    }           PNCR;
              char              wk1[327724];
              union {
                    unsigned char BYTE;
                    struct {
                           unsigned char      :1;
                           unsigned char PE6MD:1;
                           unsigned char PE5MD:1;
                           unsigned char PE4MD:1;
                           }       BIT;
                    }           PECR2;
              char              wk2;
              union {
                    unsigned char BYTE;
                    struct {
                           unsigned char      :4;
                           unsigned char PF3MD:1;
                           unsigned char PF2MD:1;
                           unsigned char PF1MD:1;
                           unsigned char PF0MD:1;
                           }       BIT;
                    }           PFCR2;
              char              wk3[15];
              union {
                    unsigned char BYTE;
                    struct {
                           unsigned char      :1;
                           unsigned char PN6MD:1;
                           unsigned char PN5MD:1;
                           unsigned char PN4MD:1;
                           unsigned char PN3MD:1;
                           unsigned char PN2MD:1;
                           unsigned char PN1MD:1;
                           unsigned char PN0MD:1;
                           }       BIT;
                    }           PNCR2;
};

#define PA     (*(volatile struct st_pa    *)0xA4000120)
#define PB     (*(volatile struct st_pb    *)0xA4000122)
#define PM     (*(volatile struct st_pm    *)0xA4000138)
#define PFC    (*(volatile struct st_pfc   *)0xA4000100)

#endif //H_KEY
